Unit uhtmlparser;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils;

Type

  TAttribut = Record
    Name: String;
    Value: String;
  End;

  PHTML = ^THTML;

  THTML = Record
    Name: String;
    Value: String;
    Attributes: Array Of TAttribut;
    SubElements: Array Of PHTML;
  End;

  // Parst einen HTML String und gibt den Baum zurück
Function HTMLStringToHTML(Data: String): PHTML;
// Gibt die PHTML Datenstruktur wieder Frei
Procedure FreeHTML(Const Data: PHTML);

Implementation

Uses lazutf8, dialogs;

Function HTMLStringToHTML(Data: String): PHTML;
Var
  //  i: Integer;
  //  scan: String;
  tmp: String;
  pptmp, ptmp: Phtml;
Begin
  result := Nil;
  // Todo : Nen Richtigen Parser Schreiben ..

  If pos('__RequestVerificationToken', data) = 0 Then exit;
  data := copy(data, pos('__RequestVerificationToken', data) + length('__RequestVerificationToken'), length(data));
  data := copy(data, pos('value="', data) + length('value="'), length(data));
  tmp := copy(data, 1, pos('"', data) - 1);

  new(result);
  result^.Name := 'form';
  result^.Value := '';
  setlength(result^.Attributes, 2);
  // <form action="/account/login" method="post">
  result^.Attributes[0].Name := 'action';
  result^.Attributes[0].Value := '/account/login';
  result^.Attributes[1].Name := 'method';
  result^.Attributes[1].Value := 'post';
  setlength(result^.SubElements, 10);

  //   <input name="__RequestVerificationToken" type="hidden" value="0fE-rgyvPw2YuifnB3sT0wv4m1Sykkr6-KIW52rCLO334b_8td2yJjSPW8nkRYp59qlWHP9oV6rjLiL1OHysoNtHJAs1" />
  new(ptmp);
  ptmp^.Name := 'input';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 3);
  ptmp^.Attributes[0].name := 'name';
  ptmp^.Attributes[0].Value := '__RequestVerificationToken';
  ptmp^.Attributes[1].name := 'type';
  ptmp^.Attributes[1].Value := 'hidden';
  ptmp^.Attributes[2].name := 'value';
  ptmp^.Attributes[2].Value := tmp;
  ptmp^.SubElements := Nil;
  result^.SubElements[0] := ptmp;

  //   <input autocomplete="on" autocorrect="off" data-val="true" data-val-required="Username&#32;is&#32;required" id="Username" name="Username" placeholder="Username" type="text" value="" />
  new(ptmp);
  ptmp^.Name := 'input';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 9);
  ptmp^.Attributes[0].name := 'autocomplete';
  ptmp^.Attributes[0].Value := 'on';
  ptmp^.Attributes[1].name := 'autocorrect';
  ptmp^.Attributes[1].Value := 'off';
  ptmp^.Attributes[2].name := 'data-val';
  ptmp^.Attributes[2].Value := 'true';
  ptmp^.Attributes[3].name := 'data-val-required';
  ptmp^.Attributes[3].Value := 'Username&#32;is&#32;required';
  ptmp^.Attributes[4].name := 'id';
  ptmp^.Attributes[4].Value := 'Username';
  ptmp^.Attributes[5].name := 'name';
  ptmp^.Attributes[5].Value := 'Username';
  ptmp^.Attributes[6].name := 'placeholder';
  ptmp^.Attributes[6].Value := 'Username';
  ptmp^.Attributes[7].name := 'type';
  ptmp^.Attributes[7].Value := 'text';
  ptmp^.Attributes[8].name := 'value';
  ptmp^.Attributes[8].Value := '';
  ptmp^.SubElements := Nil;
  result^.SubElements[1] := ptmp;

  // <span class="field-validation-valid" data-valmsg-for="Username" data-valmsg-replace="true"></span>
  new(ptmp);
  ptmp^.Name := 'span';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 3);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'field-validation-valid';
  ptmp^.Attributes[1].name := 'data-valmsg-for';
  ptmp^.Attributes[1].Value := 'Username';
  ptmp^.Attributes[2].name := 'data-valmsg-replace';
  ptmp^.Attributes[2].Value := 'true';
  ptmp^.SubElements := Nil;
  result^.SubElements[2] := ptmp;

  // <input autocomplete="off" autocorrect="off" data-val="true" data-val-required="Password&#32;is&#32;required" id="Password" name="Password" placeholder="Password" type="password" value="" />
  new(ptmp);
  ptmp^.Name := 'input';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 9);
  ptmp^.Attributes[0].name := 'autocomplete';
  ptmp^.Attributes[0].Value := 'off';
  ptmp^.Attributes[1].name := 'autocorrect';
  ptmp^.Attributes[1].Value := 'off';
  ptmp^.Attributes[2].name := 'data-val';
  ptmp^.Attributes[2].Value := 'true';
  ptmp^.Attributes[3].name := 'data-val-required';
  ptmp^.Attributes[3].Value := 'Password&#32;is&#32;required';
  ptmp^.Attributes[4].name := 'id';
  ptmp^.Attributes[4].Value := 'Password';
  ptmp^.Attributes[5].name := 'name';
  ptmp^.Attributes[5].Value := 'Password';
  ptmp^.Attributes[6].name := 'placeholder';
  ptmp^.Attributes[6].Value := 'Password';
  ptmp^.Attributes[7].name := 'type';
  ptmp^.Attributes[7].Value := 'password';
  ptmp^.Attributes[8].name := 'value';
  ptmp^.Attributes[8].Value := '';
  ptmp^.SubElements := Nil;
  result^.SubElements[3] := ptmp;

  // <span class="field-validation-valid" data-valmsg-for="Password" data-valmsg-replace="true"></span>
  new(ptmp);
  ptmp^.Name := 'span';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 3);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'field-validation-valid';
  ptmp^.Attributes[1].name := 'data-valmsg-for';
  ptmp^.Attributes[1].Value := 'Password';
  ptmp^.Attributes[2].name := 'data-valmsg-replace';
  ptmp^.Attributes[2].Value := 'true';
  ptmp^.SubElements := Nil;
  result^.SubElements[4] := ptmp;

  // <input class="btn btn-primary" type="submit" value="Log In" id="Login"/>
  new(ptmp);
  ptmp^.Name := 'input';
  ptmp^.Value := '';
  setlength(ptmp^.Attributes, 4);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'btn btn-primary';
  ptmp^.Attributes[1].name := 'type';
  ptmp^.Attributes[1].Value := 'submit';
  ptmp^.Attributes[2].name := 'value';
  ptmp^.Attributes[2].Value := 'Log In';
  ptmp^.Attributes[3].name := 'id';
  ptmp^.Attributes[3].Value := 'Login';
  ptmp^.SubElements := Nil;
  result^.SubElements[5] := ptmp;

  // <a href="/account/identify">Forgot your username or password?</a>
  new(ptmp);
  ptmp^.Name := 'a';
  ptmp^.value := 'Forgot your username or password?';
  setlength(ptmp^.Attributes, 1);
  ptmp^.Attributes[0].name := 'href';
  ptmp^.Attributes[0].Value := '/account/identify';
  ptmp^.SubElements := Nil;
  result^.SubElements[6] := ptmp;

  //  <div class="divider">
  //                <span>or</span>
  //            </div>
  new(ptmp);
  ptmp^.Name := 'div';
  ptmp^.value := '';
  setlength(ptmp^.Attributes, 1);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'divider';
  setlength(ptmp^.SubElements, 1);
  new(pptmp);
  pptmp^.Name := 'span';
  pptmp^.value := 'or';
  pptmp^.Attributes := Nil;
  pptmp^.SubElements := Nil;
  ptmp^.SubElements[0] := pptmp;
  result^.SubElements[7] := ptmp;

  // <a class="btn&#32;btn-facebook" href="/account/register/createaccountwithfacebook">Connect with Facebook</a>
  new(ptmp);
  ptmp^.Name := 'a';
  ptmp^.value := 'Connect with Facebook';
  setlength(ptmp^.Attributes, 2);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'btn&#32;btn-facebook';
  ptmp^.Attributes[1].name := 'href';
  ptmp^.Attributes[1].Value := '/account/register/createaccountwithfacebook';
  ptmp^.SubElements := Nil;
  result^.SubElements[8] := ptmp;

  // <p class="disclaimer">Geocaching will not post to your account without permission.</p>
  new(ptmp);
  ptmp^.Name := 'p';
  ptmp^.value := 'Geocaching will not post to your account without permission.';
  setlength(ptmp^.Attributes, 1);
  ptmp^.Attributes[0].name := 'class';
  ptmp^.Attributes[0].Value := 'disclaimer';
  ptmp^.SubElements := Nil;
  result^.SubElements[9] := ptmp;

  {
    If pos('<form action', data) = 0 Then exit;
    new(result);
    result^.Attributes := Nil;
    result^.Name := 'form';
    result^.SubElements := Nil;
    data := copy(data, pos('<form action', data) + length('<form '), length(data));
    data := copy(data, 1, pos('/>', data));
    data := trim(data);
    While data <> '' Do Begin
      pre := copy(data, 1, pos('=', data)-1);
  //    delete(data, 1, pos('=', data));
      If pre = '' Then Begin
        data := '';
        showmessage('Damn');
      End;
      setlength(Result^.Attributes, high(Result^.Attributes) + 2);
      Result^.Attributes[high(Result^.Attributes)].Name := pre;
      data := copy(data, pos('"', data) + 1, length(data));
      pre := copy(data, 1, pos('"', data) - 1);
      Result^.Attributes[high(Result^.Attributes)].Value := pre;
      delete(data, 1, pos('"', data));
      data := trim(data);
    End;

    //  If pos('__RequestVerificationToken', data) = 0 Then exit;
    //  data := copy(data, pos('__RequestVerificationToken', data) + length('__RequestVerificationToken'), length(data));
    //  data := copy(data, pos('value="', data) + length('value="'), length(data));
    //  tmp := copy(data, 1, pos('"', data) - 1);

    //  scan := '';
    //  For i := 1 To utf8length(data) Do Begin
    //    scan := scan + UTF8Copy(data, i, 1);
    //
    //
    //  End; }
End;

Procedure FreeHTML(Const Data: PHTML);
Var
  i: Integer;
Begin
  If assigned(data) Then Begin
    For i := 0 To high(data^.SubElements) Do Begin
      FreeHTML(data^.SubElements[i]);
    End;
    setlength(data^.SubElements, 0);
    Dispose(data);
  End;
End;

End.

